package com.yihu.figure.controller.patient;

import com.yihu.figure.controller.BaseController;
import com.yihu.figure.model.patient.PatientInfo;
import com.yihu.figure.service.PatientInfoService;
import com.yihu.figure.util.DateUtil;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import org.json.JSONObject;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.MediaType;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

/**
 * Created by chenweida on 2017/3/7.
 */
@RestController
@RequestMapping(value = "/patient", produces = MediaType.APPLICATION_JSON_UTF8_VALUE)
@Api(description = "患者信息")
public class PatientController extends BaseController {
    @Autowired
    private PatientInfoService patientInfoService;

    @ApiOperation(value = "获取患者信息")
    @RequestMapping(value = "getPatientInfo", method = RequestMethod.GET)
    public String getPatientInfo(
            @ApiParam(name = "patientCode", value = "患者code", required = true) @RequestParam(value = "patientCode", required = true) String patientCode) {
        try {
            PatientInfo patientInfo = patientInfoService.getPatientInfo(patientCode);
            JSONObject jsonObject = new JSONObject();
            jsonObject.put("name", patientInfo.getName());
            jsonObject.put("code", patientInfo.getCode());
            jsonObject.put("sex", patientInfo.getSex());
            jsonObject.put("age", DateUtil.getAgeByBirthday(patientInfo.getBirthday()));
            jsonObject.put("userPortraits", patientInfo.getUserPortraits());
            jsonObject.put("suggests", patientInfo.getSuggests());
            return write(200, "获取成功！", "patient", jsonObject);
        } catch (Exception e) {
            e.printStackTrace();
            return error(-1, e.getMessage());
        }
    }


}
